#ifndef __JB_LIST_BUTTON__
#define __JB_LIST_BUTTON__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile:   JBListButton.hpp  $
// Version        : $Revision:   1.0  $
// Function       : A button derivative that can be associated with a list box 
//                  and a process to apply to the selected items in that list 
//                  box when the button is pressed.
//
// Author         : $Author:   Len  $
// Date           : $Date:   Dec 29 1997 11:15:16  $
//
// Notes          : Originally generated by ClassWizard.
// 
// Modifications  :
//
// $Log:   D:/Documents/Len/Sources/Stuff/JBListBoxTest/PVCS/JBListButton.hpv  $
// 
//    Rev 1.0   Dec 29 1997 11:15:16   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "JBListButtonList.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// CJBListBox::ButtonList::ListButton 
///////////////////////////////////////////////////////////////////////////////

class CJBListBox::ButtonList::ListButton : public CBitmapButton
{
   public:

      // Construction and destruction

	   ListButton(CJBListBox &list, ItemProcessor *pProcessor = NULL);

      // Overrides
	   // ClassWizard generated virtual function overrides
	   //{{AFX_VIRTUAL(CJBListBox::ButtonList::ListButton)
	   //}}AFX_VIRTUAL

      // Button subclassing...

	   bool Connect(UINT nButtonID, CWnd &parentWnd);

   protected:

      // Generated message map functions
	   //{{AFX_MSG(CJBListBox::ButtonList::ListButton)
	   afx_msg void OnClicked();
	   //}}AFX_MSG

	   DECLARE_MESSAGE_MAP()

   private :

      ItemProcessor *m_pProcessor;     // The process we apply when clicked
	   CJBListBox *m_pList;             // The list we apply it to

      // Prevent copying
         
      ListButton(const ListButton &rhs);              // Do not implement
      ListButton &operator=(const ListButton &rhs);   // Do not implement
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __JB_LIST_BUTTON__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
